#Patches Menu By MrDude
import os
import pip
from os import path

python = "python"
package = 'bitstring'
firmware = str("firmware")
fusee = str("fusee-secondary.bin")
debug = 0
os.getcwd() #get current working directory
os.chdir('scripts') #change dir to scripts


def clear_screen():
    global debug
    if debug == 0:
        os.system('cls' if os.name=='nt' else 'clear')
    
def firm():
    print("Type the firmware folder address or drag the folder onto this menu:")
    global firmware
    firmware = input().replace('"', '')
    if not path.exists(firmware):
        firmware = str("firmware")

def my_load():
    print("Drag the fusee-secondary.bin or package3 file onto this menu:")
    global fusee
    fusee = input().replace('"', '')
    if not path.exists(fusee):
        if os.path.exists("fusee-secondary.bin"):
            fusee = str("fusee-secondary.bin")
        elif os.path.exists("package3"):
            fusee = str("package3")        

def install():
    try:
        return __import__(package)
    
    except ImportError:
        pip.main(['install', package])
        
def loader():
    os.system(python + ' Loader-AutoIPS.py "' + fusee + '"')

def fs():
    os.system(python + ' FS-AutoIPS.py "' + firmware + '" "keys.dat"')

def es():
    os.system(python + ' ES-AutoIPS.py "' + firmware + '" "keys.dat"')

def es_alt():
    os.system(python + ' ES-Alt-AutoIPS.py "' + firmware + '" "keys.dat"')

def es_nfim():
    os.system(python + ' ES-NFIM-AutoIPS.py "' + firmware + '" "keys.dat"')

def nca_info():
    os.system(python + ' NCA-Info.py "' + firmware + '" "keys.dat"')

def menu():
    try:
        ans=True
        while ans:
            print("=========================================================================")
            print("Make sure you have keys.dat in the scripts folder. Menu/Scripts by MrDude")
            print("=========================================================================")
            print("1.Make Atmosphere-NX Loader Patch")
            print("2.Make ES Patch and FS Patches")
            print("3.Make ES Patch")
            print("4.Make Alt Beta ES Patch")
            print("5.Make ES NFIM Patch")
            print("6.Make FS Patches")
            print("7.Toggle Debug info")
            print("8.NCA info")           
            print("9.Exit/Quit\n")
            ans=input("What would you like to do? ")
            if ans=="1":
                print("")
                my_load()
                loader()
                clear_screen()
            elif ans=="2":
                print("")
                firm()
                fs()
                es()
                clear_screen()
            elif ans=="3":
                print("")
                firm()
                es()
                clear_screen()
            elif ans=="4":
                print("")
                firm()
                es_alt()
                clear_screen()
            elif ans=="5":
                print("")
                firm()
                es_nfim()
                clear_screen()              
            elif ans=="6":
                print("")
                firm()
                fs()
                clear_screen()
            elif ans=="7":
                global debug
                if debug == 0:
                    debug = 1
                    print("Debugging enabled")
                elif debug == 1:
                    debug = 0
                    print("Debugging disabled")
            elif ans=="8":
                print("")
                clear_screen()
                debug = 1
                firm()
                nca_info()
                debug = 0            
            elif ans=="9":
                print("\n Goodbye")
                ans = None
            else:
                print("\n Not Valid Choice Try again")
    except OSError as e:
        print("Error: %s : %s" % ("In menu: ", e.strerror))             

install()
menu()